=== src/imageio/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
add_subdirectory(format)
add_subdirectory(storage)
