=== debian/changelog ===
darktable (1.4-2) unstable; urgency=low

  * Bug fix: "add LUA support", thanks to Steve Pomeroy (Closes: #735126).

 -- David Bremner <bremner@debian.org>  Sun, 12 Jan 2014 19:43:13 -0400

darktable (1.4-1) unstable; urgency=medium

  * New upstrean version; see /usr/share/doc/darktable/RELEASE_NOTES for
    upstream changes (Closes: #733246).

 -- David Bremner <bremner@debian.org>  Tue, 31 Dec 2013 08:48:23 -0400

darktable (1.4~rc1-1) experimental; urgency=low

  * Upstream release candidate; see /usr/share/doc/darktable/RELEASE_NOTES for
    upstream changes.
  * Bug fix: "segmentation fault when exporting website-gallery", thanks
    to IOhannes m zmoelnig (Closes: #709174).

 -- David Bremner <bremner@debian.org>  Tue, 03 Dec 2013 10:26:58 -0400
