## darktable 1.4.1

=== debian/changelog ===
darktable (1.4.1-1~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.

 -- David Bremner <bremner@debian.org>  Mon, 28 Apr 2014 08:08:50 +0900

darktable (1.4.1-1) unstable; urgency=medium

  [ Jackson Doak ]
  * New upstream release.
  * debian/control:
    - Update libgphoto build-depends. Closes: #736221, 739350
    - Bump standards-version to 3.9.5 (no changes)
    - Use canonical git URLs
    - Mention debug in the short description of darktable-dbg

 -- David Bremner <bremner@debian.org>  Sun, 23 Mar 2014 09:37:22 -0300
